### Algunos quandles fundamentales 
3_1 := [[1,2,3,1], [2,3,1,1], [3,1,2,1]] ;
3_1m := [[3,2,1,-1], [2,1,3,-1], [1,3,2,-1]] ;
4_1 := [[1,3,4,1], [3,1,2,1], [2,1,4,-1], [4,3,2,-1]] ;
5_1 := [[1,3,4,1], [4,1,2,1], [2,4,5,1], [5,2,3,1], [3,5,1,1]] ;
5_2 := [[1,4,5,1], [4,1,2,1], [2,3,4,1], [5,2,3,1], [3,5,1,1]] ;
6_1 := [[1, 4, 3, -1], [3, 2, 1, -1], [2, 5, 6, 1], [5, 2, 3, 1], [4, 1, 6, -1], [6, 5, 4, -1]];
6_2 := [[1, 4, 5, 1], [5, 3, 2, -1], [2, 6, 5, -1], [6, 3, 4, 1], [3, 1, 2, 1], [4, 6, 1, 1]];
6_3 := [[1, 5, 4, -1], [5, 2, 1, -1], [2, 3, 4, 1], [6, 2, 3, 1], [3, 6, 1, 1], [4, 6, 5, -1]];
7_1 := [[1, 4, 5, 1], [4, 7, 1, 1], [5, 1, 2, 1], [2, 5, 6, 1], [6, 2, 3, 1], [3, 6, 7, 1], [7, 3, 4, 1]];
7_2 := [[1, 4, 3, -1], [3, 2, 1, -1],  [2, 6, 5, -1], [5, 7, 6, -1], [7, 5, 4, -1], [4, 1, 7, -1], [6, 3, 2, -1]];
7_3 := [[1, 5, 6, 1], [5, 1, 2, 1], [2, 4, 5, 1], [6, 2, 3, 1], [3, 6, 7, 1], [7, 3, 4, 1], [4, 7, 1, 1]];
7_4 := [[5, 1, 2, 1], [2, 4, 5, 1], [4, 1, 7, -1], [6, 3, 4, 1], [3, 6, 7, 1], [7, 2, 3, 1], [1, 5, 6, 1]];
7_5 := [[1, 4, 3, -1], [5, 2, 1, -1], [2, 6, 5, -1], [7, 3, 2, -1], [3, 1, 7, -1], [4, 7, 6, -1], [6, 4, 5, 1]];
7_6 := [[6, 2, 1, -1], [2, 6, 5, -1], [4, 3, 2, -1], [3, 1, 7, -1], [1, 2, 3, 1], [7, 4, 5, 1], [5, 6, 7, 1]];
7_7 := [[1, 4, 5, 1], [6, 2, 1, -1], [2, 4, 3, -1], [7, 2, 3, 1], [3, 6, 7, 1], [5, 7, 1, 1], [4, 6, 5, -1]];
granny := [[1, 5, 6, 1], [6, 1, 2, 1], [2, 3, 4, 1], [4, 2, 3, 1], [3, 4, 5, 1], [5, 6, 1, 1]];
square := [[1, 5, 6, 1], [6, 1, 2, 1], [4, 3, 2, -1], [3, 5, 4, -1], [5, 4, 3, -1], [5, 6, 1, 1]];

ConjugationQuandle := function(group, g)
  local m, x, y, i, j, class;

  class := AsList(ConjugacyClass(group, g));
  m := NullMat(Size(class), Size(class));

  for x in class do
    i := Position(class, x);
    for y in class do
      j := Position(class, y);
      m[i][j] := Position(class, x*y*Inverse(x));
    od;
  od;
  return m;
end;

AlexanderQuandle := function(field, g)
  local l, m, x, y, i, j;

  m := NullMat(Size(field), Size(field));
  l := AsList(field);

  for x in l do
    i := Position(l, x);
    for y in l do
      j := Position(l, y);
      m[i][j] := Position(l, (One(field)-g)*x+g*y);
    od;
  od;
  return m;
end;

QuandleExtension := function(quandle, group, f)
  local m, a, b, c, u, v, x, y;
  m := NullMat(Size(group)*Size(quandle), Size(group)*Size(quandle));
  c := Cartesian(group, [1..Size(quandle)]);
  for u in c do
    for v in c do
      a := u[1];
      b := v[1];
      x := u[2];
      y := v[2];
      m[Position(c, u)][Position(c, v)] := Position(c, [b*f[x][y], quandle[x][y]]);
    od;
  od;
  return m;
end;

CheckQuandleEquation := function(equation, set, quandle)
  if quandle[set[equation[1]]][set[equation[2]]] = set[equation[3]] then
    return true;
  else
    return false;
  fi;
end;

QuandleColorings := function(fq, quandle)
  local e, i, crossing, p , set, c;

  e := [1..Size(quandle)];
  i := 0;

  c := [];
  crossing := true;

  for set in IteratorOfTuples(e, Maximum(Flat(fq))) do
    if ForAny(fq, c->CheckQuandleEquation(c, set, quandle)=false) then
      continue;
    else
      Display(set);
      Add(c, set);
    fi;
  od;
  return c;
end;

NrQuandleColorings := function(fq, quandle)
  return Size(QuandleColorings(fq, quandle));
end;

Is2Cocycle := function(quandle, f)
  local x, y, z, group; 

  group := Group(Flat(f));

  for x in [1..Size(f)] do
    for y in [1..Size(f)] do
      for z in [1..Size( f)] do
        if f[x][z]*f[quandle[x][y]][quandle[x][z]] <> f[y][z]*f[x][quandle[y][z]] then
          return false;
        fi;
      od;
    od;
  od;

  for x in [1..Size(f)] do
    if f[x][x] <> One(group) then
      return false;
    fi;
  od;

  return true;
end;

f := [ 
  [ (), (), (), () ], 
  [ (), (), (1,2), (1,2) ], 
  [ (), (1,2), (), (1,2) ], 
  [ (), (1,2), (1,2), () ] 
];

### quandle de conjugación de los 4-ciclos en S4
r := [ 
  [  1,  2,  5,  6,  4,  3 ],
  [  1,  2,  6,  5,  3,  4 ],
  [  6,  5,  3,  4,  1,  2 ],
  [  5,  6,  3,  4,  2,  1 ],
  [  3,  4,  2,  1,  5,  6 ],
  [  4,  3,  1,  2,  5,  6 ] 
];

### 2-cociclo del quandle de conjugación de los 4-ciclos en S4
g := [
  [ (), (1,2,3,4), (1,3)(2,4), (1,3)(2,4), (1,2,3,4), (1,4,3,2) ], 
  [ (1,2,3,4), (), (1,3)(2,4), (), (1,4,3,2), (1,4,3,2) ], 
  [ (1,3)(2,4), (1,2,3,4), (), (1,2,3,4), (1,3)(2,4), (1,4,3,2) ], 
  [ (1,4,3,2), (1,3)(2,4), (1,2,3,4), (), (), (1,4,3,2) ], 
  [ (1,2,3,4), (1,2,3,4), (1,2,3,4), (1,2,3,4), (), (1,2,3,4) ], 
  [ (), (), (), (), (1,2,3,4), () ] 
];

BoltzmannWeight := function(c, coloring, quandle, group, q)
  if c[4] > 0 then
    return q[coloring[c[1]]][coloring[c[2]]];
  else
    return q[coloring[c[1]]][coloring[c[2]]]^(-1);
  fi;
end;

2CocycleInvariant := function(fq, quandle, group, q)
  local e, i, crossing, p, coloring, sum, product, c, gring;

  e := [1..Size(quandle)];
  i := 0;
 
  gring := GroupRing(Integers, group);
  sum := Zero(gring);

  crossing := true;

  for coloring in IteratorOfTuples(e, Size(fq)) do 
    if ForAny(fq, c->CheckQuandleEquation(c, coloring, quandle)=false) then
      continue;
    else
      i := i+1;
      product := One(gring);
      for c in fq do
        product := product*BoltzmannWeight(c, coloring, quandle, group, q);
      od;
      sum := sum + product;
    fi;
  od;
  return sum;
end;

